// BC_QD_TestingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BC_QD_Testing.h"
#include "BC_QD_TestingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBC_QD_TestingDlg dialog

CBC_QD_TestingDlg::CBC_QD_TestingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBC_QD_TestingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBC_QD_TestingDlg)
	m_nEndBlockCount = 128;
	m_nStartBlockCount = 1;
	m_nHA = 2;
	m_nTid = 1;
	m_nLun = 0;
	m_nTotBlkstoTransfer = 30000;
	m_strResults = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBC_QD_TestingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBC_QD_TestingDlg)
	DDX_Control(pDX, IDC_LIST_RESULTS, m_LBResults);
	DDX_Text(pDX, IDC_EDIT_END_BLOCK_COUNT, m_nEndBlockCount);
	DDX_Text(pDX, IDC_EDIT_START_BLOCK_COUNT, m_nStartBlockCount);
	DDX_Text(pDX, IDC_EDIT_HBA, m_nHA);
	DDX_Text(pDX, IDC_EDIT_TARGET, m_nTid);
	DDX_Text(pDX, IDC_EDIT_LUN, m_nLun);
	DDX_Text(pDX, IDC_EDIT_BLKS_TO_TRANS, m_nTotBlkstoTransfer);
	DDX_Text(pDX, IDC_EDIT_RESULTS, m_strResults);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBC_QD_TestingDlg, CDialog)
	//{{AFX_MSG_MAP(CBC_QD_TestingDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START_TEST, OnButtonStartTest)
	ON_BN_CLICKED(IDC_BUTTON_CANCEL_TEST, OnButtonCancelTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBC_QD_TestingDlg message handlers

BOOL CBC_QD_TestingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBC_QD_TestingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBC_QD_TestingDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBC_QD_TestingDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBC_QD_TestingDlg::OnButtonStartTest() 
{
	// TODO: Add your control notification handler code here
  UpdateData(TRUE);
  
  int nBlockCount;
  eTEST_STATUS eTestStatus;
  TEST_PROGRESS_INFO sTestProgressInfo;
  CString strInfo;
  double dMBTrans,dMBPerSec;
  int nSecToDoTest;
  CButton * pButton;
  m_bCancelTesting = FALSE;

  pButton = (CButton *)GetDlgItem(IDC_BUTTON_START_TEST);
  pButton->EnableWindow(FALSE);
  pButton = (CButton *)GetDlgItem(IDC_BUTTON_CANCEL_TEST);
  pButton->EnableWindow(TRUE);

  
  nBlockCount = m_nStartBlockCount;
  while (nBlockCount <= m_nEndBlockCount)
  {
    //Here's where we do the test
    VCSCSIPrepareForNewDiskTestSequence();
    VCSCSISetTransferMode(0,nBlockCount);  //0 means all transfers are exactly nBlockCount-many blocks
                                           //1 would mean random transfers from 1-to-nBlockCount many blocks
    VCSCSIAddDiskDeviceToBeTested(m_nHA,m_nTid,m_nLun);
    VCSCSIAddDiskReadTest_Blocks(m_nTotBlkstoTransfer);
    VCSCSIStartDiskTestSequence();

    //Poll every second to see how the test is going
    eTestStatus = eTestInProgress;
    while (eTestStatus == eTestInProgress || eTestStatus == eTestNotStartedYet)
    {
      if (m_bCancelTesting == TRUE)
      {
        AfxMessageBox("Cancelling Test");

        VCSCSIStopAllDiskTest();

        pButton = (CButton *)GetDlgItem(IDC_BUTTON_START_TEST);
        pButton->EnableWindow(TRUE);
        pButton = (CButton *)GetDlgItem(IDC_BUTTON_CANCEL_TEST);
        pButton->EnableWindow(FALSE);
        return;
      }

      ::Sleep(1000);
      eTestStatus = VCSCSIGetDiskTestStatusStruct(m_nHA,m_nTid,m_nLun,0,&sTestProgressInfo);

      strInfo.Format("Blocks Transferred so far: %ld",
                     sTestProgressInfo.nNumBlocksTransSoFar);
      m_strResults = strInfo;
      UpdateData(FALSE);
      VCSCSICMQ();
    }

    //Dump out status info
    dMBTrans = (((double)m_nTotBlkstoTransfer)*512.0)/1048576.0;
    nSecToDoTest = sTestProgressInfo.nTimeRunning;
    dMBPerSec = dMBTrans/((double)nSecToDoTest);
    strInfo.Format("Blks Per Trans = %d, %ld blks trans in %d sec, MB/sec = %.2f",
                   nBlockCount,m_nTotBlkstoTransfer,nSecToDoTest,dMBPerSec);
    m_LBResults.AddString(strInfo);
    UpdateData(FALSE);
    VCSCSICMQ();

    //Prepare for next while loop
    if (nBlockCount < m_nEndBlockCount)
    {
      nBlockCount *= 2;
      if (nBlockCount > m_nEndBlockCount)
      {
        nBlockCount = m_nEndBlockCount;
      }
    }
    else
    {
      nBlockCount *= 2;
    }
  }//end while (nBlockCount <= m_nEndBlockCount)
  
  pButton = (CButton *)GetDlgItem(IDC_BUTTON_START_TEST);
  pButton->EnableWindow(TRUE);
  pButton = (CButton *)GetDlgItem(IDC_BUTTON_CANCEL_TEST);
  pButton->EnableWindow(FALSE);

  AfxMessageBox("Testing has Completed");

  UpdateData(FALSE);
}

void CBC_QD_TestingDlg::OnButtonCancelTest() 
{
	// TODO: Add your control notification handler code here
	m_bCancelTesting = TRUE;
}
