/* VCPSSL Function defines - Version 6.1.0 August 2006 */

#ifndef __VCPSSL__IMPORTS__H__
#define __VCPSSL__IMPORTS__H__

__declspec(dllimport) int VCSCSIUserATACdb(int ha, int target, int lun, BYTE *cdb, int datadir, long datalength, int buffer);
__declspec(dllimport) int VCSCSIHardReset(int ha, int target, int lun);
__declspec(dllimport) int VCSCSIGetBufferMode(int ha, int target, int lun);
__declspec(dllimport) int VCSCSISetBufferMode(int ha, int target, int lun, int mode);
__declspec(dllimport) int VCSCSIAnd(int number1, int number2);
__declspec(dllimport) int VCSCSIOr(int number1, int number2);
__declspec(dllimport) int VCSCSIXor(int number1, int number2);
__declspec(dllimport) unsigned long VCSCSIHex2Dec(BYTE *hexdata);
__declspec(dllimport) int VCSCSISegmented_FWDL(int ha, int target, int lun,char *FileName);
__declspec(dllimport) int VCSCSIDLT_FWDL(int ha, int target, int lun,char *FileName );
__declspec(dllimport) int VCSCSISDLT_FWDL(int ha, int target, int lun,char *FileName);
__declspec(dllimport) int VCSCSIIBMLTO_FWDL(int ha, int target, int lun,char *FileName);
__declspec(dllimport) int VCSCSIHPLTO_FWDL(int ha, int target, int lun,char *FileName );
__declspec(dllimport) int VCSCSISeagateLTO_FWDL(int ha, int target, int lun,char *FileName );
__declspec(dllimport) int VCSCSISonyAIT_FWDL(int ha, int target, int lun,char *FileName );


__declspec(dllimport) int VCSCSIDec2Hex(long ul, BYTE *hexdata);
__declspec(dllimport) int VCSCSISetTimeout(int sec);
__declspec(dllimport) int VCSCSIResetHBA(int hba);
__declspec(dllimport) int VCSCSIDiskCorruptBlock(int ha, int target, int lun, long sblock, int span);
__declspec(dllimport) int VCSCSIDiskGetECCSpan(int ha, int target, int lun);
__declspec(dllimport) int VCSCSIGetReadLongSize(int ha, int target, int lun);
__declspec(dllimport) int VCSCSIDiskReadLong(int ha, int target, int lun, int correct, long sblock, int bsize, int buffer);
__declspec(dllimport) int VCSCSIDiskWriteLong(int ha, int target, int lun, long sblock, int bsize,  int buffer);
__declspec(dllimport) long VCSCSIBufferSize();
__declspec(dllimport) int VCSCSIFillRandom(int buffer, int blocksize, long startingblock, int numberofblocks);
__declspec(dllimport) int VCSCSICheckRandomBlock(int buffer, int blocksize, long blocknum, long offset, int numberofblocks);
__declspec(dllimport) int VCSCSIGetRandomErrors(long *expected_blocknum, long *actual_blocknum, int *block, int *offset, int *expected_data, int *actual_data );
__declspec(dllimport) int VCSCSIDiskReadFUA(int ha, int target, int lun, int count, long sblock, long bsize, int buffer);
__declspec(dllimport) int VCSCSIDiskWriteFUA(int ha, int target, int lun, int count, long sblock, long bsize,  int buffer);
__declspec(dllimport) int VCSCSIPositionToElement(int ha, int target, int lun, int trans_add, int dest_add);
__declspec(dllimport) int VCSCSIInitializeElementStatusRange(int ha, int target,int lun, int range,int address, int num);
__declspec(dllimport) int VCSCSIInitializeElementStatus(int ha, int target,int lun);
__declspec(dllimport) int VCSCSIReadElementStatus(int ha, int target,int lun, int eltype, int start, int num, long length, BYTE *eldata);
__declspec(dllimport) int VCSCSIReadElementStatusVolTag(int ha, int target,int lun, int eltype, int start, int num, long length, BYTE *eldata);
__declspec(dllimport) int VCSCSIMoveMedium(int ha, int target, int lun, int trans_add, int source_add, int dest_add);
__declspec(dllimport) int VCSCSIFileOffset2Buffer(int buffnum, int datalen,char *FileName, long offset);
__declspec(dllimport) int VCSCSICMQ(void);
__declspec(dllimport) int VCSCSIRollPattern(int buffer, long start, long number);
__declspec(dllimport) int VCSCSIGetDLLVersion();
__declspec(dllimport) int VCSCSIHostAdapterCount();
__declspec(dllimport) int VCSCSIBuffer2File(int buffnum, int datalen, char *FileName);
__declspec(dllimport) int VCSCSIBuffer2FileLong(int buffnum, long datalen, char *FileName);
__declspec(dllimport) int VCSCSIFile2Buffer(int buffnum, int datalen, char *FileName);
__declspec(dllimport) int VCSCSIFileLong2Buffer(int buffnum, long datalen, char *FileName);
__declspec(dllimport) int VCSCSITargetCount(int ha);
__declspec(dllimport) int VCSCSIGetVendor(int ha, int target, int lun, char *VendorString);
__declspec(dllimport) int VCSCSIGetProduct(int ha, int target, int lun, char *ProductString);
__declspec(dllimport) int VCSCSIGetVersion(int ha, int target, int lun,char *VersionString);
__declspec(dllimport) int VCSCSIInquiry(int ha, int target, int lun, BYTE *inqdata);
__declspec(dllimport) int VCSCSIInquiryEVPD(int ha, int target, int lun, int page, BYTE *inqdata);
__declspec(dllimport) int VCSCSITUR(int ha, int target, int lun);
__declspec(dllimport) int VCSCSIGetDeviceType(int ha, int target, int lun);
__declspec(dllimport) int VCSCSIDiskStartStop(int ha, int target, int lun, int start);
__declspec(dllimport) int VCSCSIDiskUnload(int ha, int target, int lun);
__declspec(dllimport) int VCSCSIDiskFormat(int ha, int target, int lun, int mode);
__declspec(dllimport) int VCSCSIViewSense( BYTE *reqsendata);
__declspec(dllimport) int VCSCSIReadCapacity(int ha, int target, int lun, long * highblock_l, long * blocksize_l);
__declspec(dllimport) int VCSCSIDiskRead(int ha, int target, int lun, int count, long sblock, long bsize, int buffer);
__declspec(dllimport) int VCSCSIDiskWrite(int ha, int target, int lun, int count, long sblock, long bsize,  int buffer);
__declspec(dllimport) int VCSCSIFillBuffer(int buffer, long numbytes, int patternsize,BYTE *bufferdata);
__declspec(dllimport) int VCSCSIFillPattern(int buffer, int pattern);
__declspec(dllimport) int VCSCSIFillBlockNum(int buffer, long sblock, int count, int blocksize);
__declspec(dllimport) int VCSCSISearchBuffer(int buffer, BYTE *searchdata, int searchsize, long searchlength);
__declspec(dllimport) int VCSCSILoadBuffer(int buffer, long numbytes, BYTE *bufferdata);
__declspec(dllimport) int VCSCSIGetBuffer(int buffer, long numbytes, BYTE *bufferdata);
__declspec(dllimport) int VCSCSICompareBuffers(long startbyte, long numbytes);
__declspec(dllimport) int VCSCSIUserCdb(int ha, int target, int lun, BYTE *cdb, int cdblength, int datadir, long datalength, int buffer);
__declspec(dllimport) int VCSCSIUserCdbTimeout(int ha, int target, int lun, BYTE *cdb, int cdblength, int datadir, long datalength, int buffer, int tOut);
__declspec(dllimport) int VCSCSIUserCdbReportUnderOverrun(int ha, int target, int lun, BYTE *cdb, int cdblength, int datadir, long datalength, int buffer);
__declspec(dllimport) int VCSCSIGetTapeCapacity( int ha, int target, int lun, long *TBS );
__declspec(dllimport) int VCSCSISetTapeBlocksize(int ha, int target, int lun, long blocksize);
__declspec(dllimport) int VCSCSITapeRewind(int ha, int target, int lun, int immediate);
__declspec(dllimport) int VCSCSITapeUnload(int ha, int target, int lun, int immediate);
__declspec(dllimport) int VCSCSITapeWFM(int ha, int target, int lun);
__declspec(dllimport) int VCSCSITapeReadF(int ha, int target, int lun, int count, int buffer);
__declspec(dllimport) int VCSCSITapeWriteF(int ha, int target, int lun, int count, int buffer);
__declspec(dllimport) int VCSCSITapeReadV(int ha, int target, int lun, int buffer);
__declspec(dllimport) int VCSCSITapeReadVL(int ha, int target, int lun, long count, int buffer);
__declspec(dllimport) int VCSCSITapeWriteV(int ha, int target, int lun, long count, int buffer);
__declspec(dllimport) int VCSCSITapeFSF(int ha, int target, int lun);
__declspec(dllimport) int VCSCSITapeFSR(int ha, int target, int lun);
__declspec(dllimport) int VCSCSITapeSpaceEOD(int ha, int target, int lun);
__declspec(dllimport) int VCSCSIModeSense(int ha, int target, int lun, int page, int pagecode, BYTE *modedata);
__declspec(dllimport) int VCSCSIModeSelect(int ha, int target, int lun,  int sp, BYTE *modedata);
__declspec(dllimport) int VCSCSIModeSenseFull(int ha, int target, int lun, int page, int pagecode, BYTE *modedata);
__declspec(dllimport) int VCSCSIModeSelectFull(int ha, int target, int lun,  int sp, BYTE *modedata);
__declspec(dllimport) int VCSCSILogSense(int ha, int target, int lun, int page, int pagecode, BYTE *modedata);
__declspec(dllimport) int VCSCSILogSelect(int ha, int target, int lun,  int sp, BYTE *modedata);
__declspec(dllimport) int VCSCSIGetErrorDetails(int *iostat, int *hbastat, int *scsistat);
__declspec(dllimport) int VCSCSISleep(int nNumMilliseconds);

typedef  struct membuf {
	char bfr[0x01ff];
} membuf;
__declspec(dllimport) membuf * bb;


__declspec(dllimport) int VCSCSIIssueThreadedCDB(int nHA,int nTid,int nLun,BYTE * pCDBBytes,int nCDBLen,BYTE * pInOutBuf,int nInOutBufLen,int nDirection,int nTimeout);
__declspec(dllimport) int VCSCSIGetThreadedCDBStatus(int nThrdID);
__declspec(dllimport) int VCSCSIGetThreadedCDBStatusWData(int nThrdID,BYTE * pSenseBuf,int nSenseBufLen,double * pTimeToDoCmd,BYTE * pInOutBuf,int nInOutBufLen);
__declspec(dllimport) BOOL VCSCSIReleaseThreadID(int nThrdID);

//EXPORTS FOR PUTTING Disk Manufacturing Module INTO DTB
enum ePATTERN_TYPE {eAllZeros,eAllOnes,
                    eAltZeroAndOne,eAltOneAndZero,
                    eIncrementing,eDecrementing,
                    eLBA,
                    eRandom,
                    eUserPat,
                    eUserPatBinary,
                    eWalkingZeros,eWalkingOnes,
                    eAlt1And0ThenAlt0And1,eAlt0And1ThenAlt1And0,
                    e2To1Compressable,
                    eNoPattern
                   };

enum eTEST_STATUS {eTestInProgress,eCompleteOnSuccess,eCompleteOnFailure,
                   eTestNotStartedYet,eTestIsPaused,eTestStopped,
                   eErrorOnParamsPassed,eMisCompare,eInvalidBlock,
                   ePendingIOOutstanding,eUnknownStatus
                  };

struct _TEST_PROGRESS_INFO
{
  int    nSizeOfThisStruct;
  DWORD  dwTestStatus;
  int    nNumBlocksTransSoFar;
  double dNumBytesTransSoFar;
  time_t testStartTime;
  time_t testEndTime;
  time_t testPauseTime;
  int    nNumTotBlocksToTransfer;
  int    nTimeRunning;
  int    nTimeRemaining;

  //CTOR
  _TEST_PROGRESS_INFO() {nSizeOfThisStruct = 5*sizeof(int)+sizeof(DWORD)+sizeof(double)+3*sizeof(time_t);
                         nNumBlocksTransSoFar = 0;
                         dNumBytesTransSoFar = 0.0;
                         testStartTime = 0;
                         testEndTime = 0;
                         testPauseTime = 0;
                         nNumTotBlocksToTransfer = 0;
                         nTimeRunning = 0;
                         nTimeRemaining = 0;
                        }
};
typedef struct _TEST_PROGRESS_INFO TEST_PROGRESS_INFO;



__declspec(dllimport) BOOL VCSCSIPrepareForNewDiskTestSequence();
__declspec(dllimport) BOOL VCSCSIStartDiskTestSequence();
__declspec(dllimport) BOOL VCSCSIAddDiskDeviceToBeTested(int nHA,int nTid,int nLun);

__declspec(dllimport) BOOL VCSCSIAddDiskWriteTest_Time(int nNumberOfMinutes = 1,int nRandomOrSeq = 1,int nStartLBA = 0,ePATTERN_TYPE ePatType = eIncrementing,char * pstrPatternFile = NULL,BOOL bOverlayLBA =  FALSE);
__declspec(dllimport) BOOL VCSCSIAddDiskWriteTest_Blocks(long lNumBlocksToWrite = -1,int nRandomOrSeq = 1,int nStartLBA = 0,ePATTERN_TYPE ePatType = eIncrementing,char * pstrPatternFile = NULL,BOOL bOverlayLBA =  FALSE);

__declspec(dllimport) BOOL VCSCSIAddDiskReadTest_Time(int nNumberOfMinutes = 1,int nRandomOrSeq = 1,int nStartLBA = 0,ePATTERN_TYPE ePatType = eIncrementing,char * pstrPatternFile = NULL,BOOL bOverlayLBA = FALSE,BOOL bCompareData = FALSE);
__declspec(dllimport) BOOL VCSCSIAddDiskReadTest_Blocks(long lNumBlocksToWrite = -1,int nRandomOrSeq = 1,int nStartLBA = 0,ePATTERN_TYPE ePatType = eIncrementing,char * pstrPatternFile = NULL,BOOL bOverlayLBA = FALSE,BOOL bCompareData = FALSE);

__declspec(dllimport) BOOL VCSCSIAddDiskWriteReadTest_Time(int nNumberOfMinutes = 1,int nRandomOrSeq = 1,int nStartLBA = 0,ePATTERN_TYPE ePatType = eIncrementing,char * pstrPatternFile = NULL,BOOL bOverlayLBA = FALSE,BOOL bCompareData = FALSE);
__declspec(dllimport) BOOL VCSCSIAddDiskWriteReadTest_Blocks(long lNumBlocksToWrite = -1,int nRandomOrSeq = 1,int nStartLBA = 0,ePATTERN_TYPE ePatType = eIncrementing,char * pstrPatternFile = NULL,BOOL bOverlayLBA = FALSE,BOOL bCompareData = FALSE);

__declspec(dllimport) BOOL VCSCSIAddDiskSeekTest_Time(int nNumberOfMinutes = 1,int nRandomOrSeq = 1,int nStartLBA = 0);
__declspec(dllimport) BOOL VCSCSIAddDiskSeekTest_Blocks(long lNumBlocksToWrite = -1,int nRandomOrSeq = 1,int nStartLBA = 0);

__declspec(dllimport) BOOL VCSCSIAddDiskVerifyTest_Time(int nNumberOfMinutes = 1,int nRandomOrSeq = 1,int nStartLBA = 0);
__declspec(dllimport) BOOL VCSCSIAddDiskVerifyTest_Blocks(long lNumBlocksToVerify = -1,int nRandomOrSeq = 1,int nStartLBA = 0);

__declspec(dllimport) BOOL VCSCSIAddDiskWriteVerifyTest_Time(int nNumberOfMinutes = 1,int nRandomOrSeq = 1,int nStartLBA = 0,ePATTERN_TYPE ePatType = eIncrementing,char * pstrPatternFile = NULL,BOOL bOverlayLBA = FALSE,BOOL bByteCheck = FALSE);
__declspec(dllimport) BOOL VCSCSIAddDiskWriteVerifyTest_Blocks(long lNumBlocksToVerify = -1,int nRandomOrSeq = 1,int nStartLBA = 0,ePATTERN_TYPE ePatType = eIncrementing,char * pstrPatternFile = NULL,BOOL bOverlayLBA = FALSE,BOOL bByteCheck = FALSE);

__declspec(dllimport) BOOL VCSCSIAddDiskFormatTest_SameSize();
__declspec(dllimport) BOOL VCSCSIAddDiskFormatTest_NewSize(int nNewBlockSize);
__declspec(dllimport) BOOL VCSCSIAddDiskFWDownloadTest(char * pFirmwareFileName);

__declspec(dllimport) BOOL VCSCSIAddDiskSpinTest(int nNumberOfMinutes = 1);
__declspec(dllimport) BOOL VCSCSIAddDiskSynchronizeTest();
__declspec(dllimport) BOOL VCSCSIAddDiskExternalProgramTest(char * pProgramName);

__declspec(dllimport) eTEST_STATUS VCSCSIGetDiskTestStatus(int nHA,int nTid,int nLun,int nTestNumber);
__declspec(dllimport) eTEST_STATUS VCSCSIGetDiskTestStatusWData(int nHA,int nTid,int nLun,int nTestNumber,BYTE * pSenseBuf,int nSenseBufLen);
__declspec(dllimport) eTEST_STATUS VCSCSIGetDiskTestStatusStruct(int nHA,int nTid,int nLun,int nTestNumber,TEST_PROGRESS_INFO * pTestProgressInfo);

__declspec(dllimport) BOOL VCSCSIPauseDiskTest(int nHA,int nTid,int nLun,int nTestNumber);
__declspec(dllimport) BOOL VCSCSIResumeDiskTest(int nHA,int nTid,int nLun,int nTestNumber);
__declspec(dllimport) BOOL VCSCSIStopDiskTest(int nHA,int nTid,int nLun,int nTestNumber);
__declspec(dllimport) BOOL VCSCSIStopAllDiskTest();

__declspec(dllimport) int VCSCSISetTransferMode(int nTransferMode,int nMaxBlksPerTransfer);
__declspec(dllimport) int VCSCSIGetTransferMode(int * pnTransferMode,int * pnMaxBlksPerTransfer);
//END EXPORTS FOR PUTTING Disk Manufacturing Module INTO DTB


//EXPORTS FOR PUTTING Tape Manufacturing Module INTO DTB
enum eSPACE_TYPE_TAPE {eForwardToBlockTape,eBackwardToBlockTape,
                       eForwardToFilemarkTape,eBackwardToFilemarkTape,
                       eForwardToEODTape,eBackwardToEODTape,
                       eSpaceNoneTape
                      };

enum eCOMPRESSION_TYPE_TAPE {eCompressionONTape,eCompressionOFFTape,
                             eCompressionNoneTape
                            };

enum eLOGPAGE_TYPE_TAPE {eLogPageClearTape,eLogPageSaveTape,
                         eLogPageNoneTape
                        };

__declspec(dllimport) BOOL VCSCSIPrepareForNewTapeTestSequence();

__declspec(dllimport) BOOL VCSCSIStartTapeTestSequence();

__declspec(dllimport) BOOL VCSCSIAddTapeDeviceToBeTested(int nHA,int nTid,int nLun);

__declspec(dllimport) eTEST_STATUS VCSCSIGetTapeTestStatus(int nHA,int nTid,int nLun,int nTestNumber);
__declspec(dllimport) eTEST_STATUS VCSCSIGetTapeTestStatusWData(int nHA,int nTid,int nLun,int nTestNumber,BYTE * pSenseBuf,int nSenseBufLen);
__declspec(dllimport) eTEST_STATUS VCSCSIGetTapeTestStatusFull(int nHA,int nTid,int nLun,int nTestNumber,
                                                               BYTE * pCDBBuf,int nCDBBufLen,
                                                               BYTE * pSenseBuf,int nSenseBufLen,
                                                               int * pRunningTime,int * pTimeRemaining);

__declspec(dllimport) BOOL VCSCSIAddTapeWriteTest_Time(int nNumberOfMinutes = 1,
                                                       enum ePATTERN_TYPE ePatType =  eIncrementing,
                                                       char * pstrPatternFile = NULL);

__declspec(dllimport) BOOL VCSCSIAddTapeWriteTest_MBytes(int nNumMBytesToWrite = 1,
                                                         enum ePATTERN_TYPE ePatType =  eIncrementing,
                                                         char * pstrPatternFile = NULL);

__declspec(dllimport) BOOL VCSCSIAddTapeReadTest_Time(int nNumberOfMinutes = 1,
                                                      enum ePATTERN_TYPE ePatType = eIncrementing,
                                                      char * pstrPatternFile = NULL,
                                                      BOOL bCompareData = FALSE);

__declspec(dllimport) BOOL VCSCSIAddTapeReadTest_MBytes(int nNumMBytesToWrite = 1,
                                                        enum ePATTERN_TYPE ePatType = eIncrementing,
                                                        char * pstrPatternFile = NULL,
                                                        BOOL bCompareData = FALSE);

__declspec(dllimport) BOOL VCSCSIAddTapeWriteFMTest();

__declspec(dllimport) BOOL VCSCSIAddTapeReadFMTest();

__declspec(dllimport) BOOL VCSCSIAddTapeRewindTest();

__declspec(dllimport) BOOL VCSCSIAddTapeSpaceTest(enum eSPACE_TYPE_TAPE eSpaceType = eForwardToEODTape);

__declspec(dllimport) BOOL VCSCSIAddTapeCompressionTest(enum eCOMPRESSION_TYPE_TAPE eCompType = eCompressionONTape);

__declspec(dllimport) BOOL VCSCSIAddTapeLogPageTest(enum eLOGPAGE_TYPE_TAPE eLogType = eLogPageClearTape);

__declspec(dllimport) BOOL VCSCSIAddTapeSynchronizeTest();

__declspec(dllimport) BOOL VCSCSIAddTapeExternalProgramTest(char * pProgramName);

__declspec(dllimport) BOOL VCSCSIPauseTapeTest(int nHA,int nTid,int nLun,int nTestNumber);

__declspec(dllimport) BOOL VCSCSIResumeTapeTest(int nHA,int nTid,int nLun,int nTestNumber);

__declspec(dllimport) BOOL VCSCSIStopTapeTest(int nHA,int nTid,int nLun,int nTestNumber);

__declspec(dllimport) BOOL VCSCSIStopAllTapeTest();

__declspec(dllimport) int VCSCSISetKBytesPerTransfer(int nKBytesPerTransfer);
__declspec(dllimport) int VCSCSIGetKBytesPerTransfer(int * pnKBytesPerTransfer);
//END EXPORTS FOR PUTTING Tape Manufacturing Module INTO DTB


// Protocol exports

__declspec(dllimport) int	VCSCSIPHostAdapterCount();
__declspec(dllimport) int	VCSCSIPValidTarget(long ha, long target);
__declspec(dllimport) int	VCSCSIPHbaTarget(long ha);
__declspec(dllimport) int	VCSCSIPSetSpeed5(long ha, long target);
__declspec(dllimport) int	VCSCSIPSetSpeed10(long ha, long target);
__declspec(dllimport) int	VCSCSIPSetSpeed20(long ha, long target);
__declspec(dllimport) int	VCSCSIPSetSpeed40(long ha, long target);
__declspec(dllimport) int	VCSCSIPSetSpeed80(long ha, long target);
__declspec(dllimport) int	VCSCSIPSetSpeed160(long ha, long target);
__declspec(dllimport) int	VCSCSIPSetSpeed320(long ha, long target);
__declspec(dllimport) int	VCSCSIPSetWide(long ha, long target);
__declspec(dllimport) int	VCSCSIPSetNarrow(long ha, long target);
__declspec(dllimport) int	VCSCSIPSetNegotiated(long ha, long target, int offset, int period, bool iu, bool dt, bool qas, bool wide);
__declspec(dllimport) int	VCSCSIPResetBus(long ha);
__declspec(dllimport) int	VCSCSIPGetNegotiated(long ha, long target, int * offset, int * period, int * iu, int * dt, int * qas, int * wide);



//Buffer lengths needed
#define BUF_LEN_VENDOR 17
#define BUF_LEN_PRODUCT 17
#define BUF_LEN_VERSION 5
#define BUF_LEN_DEC2HEX 4
#define BUF_LEN_INQUIRY 64
#define BUF_LEN_VIEWSENSE 16
#define BUF_LEN_MODESENSESELECT 256

#define BAD_THREAD_ID 0

#endif
